//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UJPEG.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Uframe1"
#pragma link "Uframe2"
#pragma link "UFrame3"
#pragma resource "*.dfm"
#include "jpeg.h"
#include <stdio.h>
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
   original=tdcs=tdci=zigZag=cuantizada=NULL;

   M=N=0;
   M=Frame11->Image1->Height;
   N=Frame11->Image1->Width;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
   StatusBar1->SimpleText="";
   if(!OpenPictureDialog1->Execute())
      return;
   Frame11->Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
   if(original!=NULL)
      liberarMatriz(original, M,N);
   M=Frame11->Image1->Height;
   N=Frame11->Image1->Width;

   Frame21->Image2->Height=M;
   Frame21->Image2->Width=N;
   Frame31->Image3->Height=M;
   Frame31->Image3->Width=N;
   Frame21->Image2->Picture->Assign(Frame11->Image1->Picture);
   Frame31->Image3->Picture->Assign(Frame11->Image1->Picture);



   original=nuevaMatriz<double>(M,N);
   copiarImagen(Frame11->Image1, original);
   normalizar(original,M,N);
   multiplicar(original,M,N,1000.0);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
   StatusBar1->SimpleText="";
   if(original==NULL)
      return;
   double **pedazo;
   if(tdcs==NULL)
      tdcs=nuevaMatriz<double>(M,N);
   for(int f=0;f<M;f+=8)
      for(int c=0;c<N;c+=8)
         {
            original+=f;
            for (int k=0;k<8;k++)
               original[k]+=c;
            pedazo=TDCs(original,8,8);
            for (int k=0;k<8;k++)
               original[k]-=c;
            original-=f;
            for(int i=0;i<8;i++)
               for(int j=0;j<8;j++)
                  tdcs[f+i][c+j]=pedazo[i][j];
            liberarMatriz<double>(pedazo,8,8);
         }
   mostrarImagen(tdcs,Frame21->Image2);
}
//---------------------------------------------------------------------------
double round(double x)
   {
      double xf=floor(x), xc=ceil(x);
      return (x-xf)<(xc-x)?xf:xc;
   }
void __fastcall TForm1::BitBtn4Click(TObject *Sender)
{
   StatusBar1->SimpleText="";
   if(tdcs==NULL)
      {
         StatusBar1->SimpleText="Debe aplicar la transformada de Coseno antes de cuantizar...";
         return;
      }
   if(cuantizada==NULL)
      cuantizada=nuevaMatriz<double>(M,N);

   double **Q=nuevaMatriz<double>(8,8);
   double calidad=Edit1->Text.ToDouble();
   for(int i=0;i<8;i++)
      for(int j=0;j<8;j++)
         Q[i][j]=1+(1+i+j)*calidad;

   for(int f=0;f<M;f+=8)
      for(int c=0;c<N;c+=8)
         {
            for(int i=0;i<8;i++)
               for(int j=0;j<8;j++)
                  cuantizada[f+i][c+j]=round(tdcs[f+i][c+j]/Q[i][j]);
         }
   liberarMatriz<double>(Q,8,8);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn5Click(TObject *Sender)
{
   StatusBar1->SimpleText="";
   if(cuantizada==NULL)
      {
         StatusBar1->SimpleText="Debe cuantizar la transformada de Coseno antes de invertir...";
         return;
      }
   double **pedazo;

   if(tdci==NULL)
      tdci=nuevaMatriz<double>(M,N);

   double **Q=nuevaMatriz<double>(8,8);
   double calidad=Edit1->Text.ToDouble();
   for(int i=0;i<8;i++)
      for(int j=0;j<8;j++)
         Q[i][j]=1.0/(1+(1+i+j)*calidad);


   for(int f=0;f<M;f+=8)
      for(int c=0;c<N;c+=8)
         {
            cuantizada+=f;
            for (int k=0;k<8;k++)
               cuantizada[k]+=c;
            //----decuantizar---------
            for(int i=0;i<8;i++)
               for(int j=0;j<8;j++)
                  cuantizada[i][j]/=Q[i][j];
            //------------------------

            pedazo=TDCis(cuantizada,8,8);
            for (int k=0;k<8;k++)
               cuantizada[k]-=c;
            cuantizada-=f;
            for(int i=0;i<8;i++)
               for(int j=0;j<8;j++)
                  tdci[f+i][c+j]=pedazo[i][j];
            liberarMatriz(pedazo,8,8);
         }
   liberarMatriz(Q,8,8);
      mostrarImagen(tdci,Frame31->Image3);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn6Click(TObject *Sender)
{
   StatusBar1->SimpleText="";
   if (cuantizada==NULL)
      {
         StatusBar1->SimpleText="Debe cuantizar la transformada de Coseno antes de obtener las diferencias...";
         return;
      }
   if(zigZag!=NULL)
      liberarMatriz<double>(zigZag,M,N);
   zigZag=diferenciarEnZigZag(cuantizada,M,N);
   mostrarImagen(cuantizada,Frame21->Image2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn7Click(TObject *Sender)
{
   StatusBar1->SimpleText="";
   StatusBar1->SimpleText=entropia(original,M,N);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn8Click(TObject *Sender)
{
   StatusBar1->SimpleText="";
   if(zigZag==NULL)
      {
         StatusBar1->SimpleText="Debe obtener la imagen de diferencias antes de calcular su entropia...";
         return;
      }
   StatusBar1->SimpleText=entropia(zigZag,M,N);
}
//---------------------------------------------------------------------------


